{
    "$graph": [
        {
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": "File",
                    "id": "#cat.cwl/r"
                }
            ],
            "arguments": [
                "cat",
                "$(inputs.r.path)"
            ],
            "id": "#cat.cwl",
            "outputs": []
        },
        {
            "class": "CommandLineTool",
            "inputs": [
                {
                    "type": "string",
                    "id": "#echo.cwl/r"
                },
                {
                    "type": "string",
                    "default": "import sys\nprint(sys.argv[1])\nif sys.argv[1] == \"2\":\n  exit(1)\nelse:\n  f = open(\"foo\"+sys.argv[1]+\".txt\", \"wb\")\n  content = sys.argv[1]+\"\\n\"\n  f.write(content.encode('utf-8'))\nif sys.argv[1] == \"5\":\n  exit(1)\n",
                    "id": "#echo.cwl/script"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "foo$(inputs.r).txt"
                    },
                    "id": "#echo.cwl/out"
                }
            ],
            "arguments": [
                "python",
                "-c",
                "$(inputs.script)",
                "$(inputs.r)"
            ],
            "id": "#echo.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "string"
                    },
                    "default": [
                        "1",
                        "2",
                        "3"
                    ],
                    "id": "#main/range"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/step1/out",
                    "id": "#main/out"
                }
            ],
            "steps": [
                {
                    "in": [
                        {
                            "source": "#main/range",
                            "id": "#main/step1/r"
                        }
                    ],
                    "scatter": "#main/step1/r",
                    "out": [
                        "#main/step1/out"
                    ],
                    "run": {
                        "class": "Workflow",
                        "id": "#main/step1/subtool",
                        "inputs": [
                            {
                                "type": "string",
                                "id": "#main/step1/subtool/r"
                            }
                        ],
                        "outputs": [
                            {
                                "type": "File",
                                "outputSource": "#main/step1/subtool/sstep1/out",
                                "id": "#main/step1/subtool/out"
                            }
                        ],
                        "steps": [
                            {
                                "in": [
                                    {
                                        "source": "#main/step1/subtool/r",
                                        "id": "#main/step1/subtool/sstep1/r"
                                    }
                                ],
                                "out": [
                                    "#main/step1/subtool/sstep1/out"
                                ],
                                "run": "#echo.cwl",
                                "id": "#main/step1/subtool/sstep1"
                            },
                            {
                                "in": [
                                    {
                                        "source": "#main/step1/subtool/sstep1/out",
                                        "id": "#main/step1/subtool/sstep2/r"
                                    }
                                ],
                                "out": [],
                                "run": "#cat.cwl",
                                "id": "#main/step1/subtool/sstep2"
                            }
                        ]
                    },
                    "id": "#main/step1"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
